//
//  CFWiiRemote.h
//  CFWiiRemote
//
//  Created by saskia on 01/08/07. rd: 01/08/07
//  Copyright 2007 Steim. All rights reserved.
//

#import <Cocoa/Cocoa.h>


#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>
#import <IOBluetooth/IOBluetoothUserLib.h>
#import <WiiRemote/WiiRemote.h>
#import <WiiRemote/WiiRemoteDiscovery.h>

enum{
	kWiiIsNotStarted = 0,
	kWiiIsNotConnected,
	kWiiIsConnected,
	kWiiWithNunchukConnected
};

enum{
	
	A_BtnID = 0,
	B_BtnID,
	One_BtnID,
	Two_BtnID,
	Minus_BtnID,
	Home_BtnID,
	Plus_BtnID,
	Up_BtnID,
	Down_BtnID,
	Left_BtnID,
	Right_BtnID,
	
	Z_NunchukBtnID,
	C_NunchukBtnID,

	
	X_AccID,
	Y_AccID,
	Z_AccID,
	
	X_IRPointID,
	Y_IRPointID,
	
	// values of attached Nunchuk
	// values of attached Nunchuk
	
	X_NunchukAccID,
	Y_NunchukAccID,
	Z_NunchukAccID,
	
	X_NunchukJoystickID,
	Y_NunchukJoystickID
};

#define  kNumControls    23


@interface CFWiiRemote : NSObject {

	WiiRemoteDiscovery* _discovery;
	WiiRemote*    _wii;
	int           _wiiID;
	BOOL          _nunchukAttached;
	BOOL          _wiiDiscoveryStarted;
	BOOL          _batteryChecked;
	float         _ElementValues[32];
	NSArray* _NunchukElements;
	NSMutableArray* _WiiRemoteElements;
	
	
	
}
- (id)   init:(int)wiiNum;
- (BOOL)   startDiscovery:(BOOL)warn;
- (BOOL)   stopDiscovery;
- (BOOL)   closeWiiConnection;
- (BOOL)   setForceFeedbackEnabled:(bool)enabled;
- (BOOL) setLEDEnabled1:(bool)enabled1 enabled2:(bool)enabled2 enabled3:(bool)enabled3 enabled4:(bool)enabled4;
- (BOOL) setIRSensorEnabled:(bool)enabled;

- (float)  getValueOfWiiElement:(int)elementID;
- (void) checkWiiBatteryLevel;
- (void) setupElementInfo;
- (NSArray*)WiiRemoteElements;




- (BOOL) wiiConnected;
- (BOOL) nunchukAttached;
- (BOOL) wiiDiscoveryStarted;


@end
